package  
{
	import com.greensock.easing.Expo;
	import com.greensock.TweenLite;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	/**
	 * ...
	 * @author Kokurin S.V.
	 */
	public class Gallery3D extends Sprite
	{
		private var container:MovieClip;	//здесь будут лежать все наши картинки
		private var loader:URLLoader;		//через эту штуковину загружается XML
		private var list:XMLList;			//XML конвертируется потом в XMLList для более удобного извлечения информации
		private var size:uint = 3;			//размер галереи, т.е. 3х3 картинки
		private var tw:uint = 100;			//размер превью картинки по ширине
		private var th:uint = 75;			//по высоте
		private var r0 = 200 * 298 / (375 - 298);	//особый параметр, превносит магию в нашу галерею
		private var wid:uint = stage.stageWidth;	//ширина сцены
		private var hei:uint = stage.stageHeight;	//высота сцены
		
		public function Gallery3D() 
		{
			init();		//инициализация
			loadXML();	//грузим XML
		}
		private function init():void
		{
			//создаем наш контейнер и устанавливаем его по центру
			container = new MovieClip();
			container.x = wid / 2;
			container.y = hei / 2;
			
			//определяем размеры галереи по ширине и высоте
			var sizeX:uint = tw * size + tw / 10 * (size + 1);
			var sizeY:uint = th * size + th / 10 * (size + 1);
			
			//определяем как далеко должен находится контейнер, чтоб всё помещалось.
			container.z = Math.max(r0 * sizeX / wid - r0, r0 * sizeY / hei - r0, 0);
			container.z0 = container.z;	//запоминаем это расстояние в только что созданной переменной, хорошо что MovieClip это динамический класс
			addChild(container);	//добавляем его на сцену
			cover.addEventListener(MouseEvent.CLICK, zoomOut);	//задаем функцию для обработки клика мыши по нашему "ковру"
		}
		private function loadXML():void
		{
			//говорим откуда грузить XML
			loader = new URLLoader(new URLRequest("images.xml"));
			//задаем функцию, которая будет запущена как только XML загрузится
			loader.addEventListener(Event.COMPLETE, createGallery);
		}
		private function createGallery(e:Event):void
		{
			//получаем загруженный XML
			var xml:XML = new XML(e.target.data);
			list = new XMLList(xml.image); //и конвертируем его в XMLList
			for (var i:uint = 0; i < size; i++)	//в этом цикле мы создадим нашу галерею
			{
				for (var j:uint = 0; j < size; j++)
				{
					var t:MovieClip = new MovieClip(); //в этом мувике будет лежать загруженная картинка
					//рисуем серый фон чтоб показывать хоть что-то, пока картинка не загрузилась
					t.graphics.beginFill(0x999999);
					t.graphics.drawRect( -tw / 2, -th / 2, tw, th);
					t.graphics.endFill();
					
					//задаем позицию на сцене и добавляем мувик в контейнер
					t.x = (i - (size-1) / 2) * tw*1.1;
					t.y = (j - (size-1) / 2) * th*1.1;
					container.addChild(t);
					//создаем объект, который будет загружать картинку
					var l:Loader = new Loader();
					l.load(new URLRequest(list[i + 3 * j].@thumb));	//достаем адрес превью из XMLList
					//задаем позицию лоадера в мувике и добавляем его туда
					l.x = -tw / 2;
					l.y = -th / 2;
					t.addChild(l);
					t.addEventListener(MouseEvent.CLICK, zoomIn);//по нажатии мышки на любом мувике будем увеличивать галерею
					t.buttonMode = true;	//благодаряэтой опции курсор будет превразщаться в "руку", говоря что картика кликабельна
				}
			}
		}
		private function zoomIn(e:MouseEvent):void
		{
			//узнаем куда нужно передвинуть наш контейнер, чтобы картинка, по которой кликнули, оказалась в центре
			var nx:int = wid/2-e.target.parent.x;
			var ny:int = hei / 2 - e.target.parent.y;
			//узнаем куда надо сдвинуть контейнер по оси Z, чтобы картинка заняла почти всю сцену
			//здесь опять включаем немного магии:)
			var nz:int = Math.max(r0 * tw*1.2 / wid - r0, r0 * th*1.2 / hei - r0);
			
			//создаем твин для плавного изменения нужных параметров за одну секунду
			var ttt:TweenLite = new TweenLite(container, 1, { x:nx, y: ny, z:nz, ease:Expo.easeInOut} );
		}
		private function zoomOut(e:MouseEvent):void
		{
			//почти то же самое, что в zoomIm, только другие параметры
			var ttt:TweenLite = new TweenLite(container, 1, { x:wid/2, y: hei/2, z:container.z0, ease:Expo.easeInOut} );
		}
	}

}